﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;

namespace CustomSettingsPane
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			var graphSource = new ObservableGraphSourceBase<MyNode, LinkViewModelBase<MyNode>>();
			graphSource.AddNode(new MyNode()
			{
				CustomProp = "First item"
			});
			graphSource.AddNode(new MyNode()
			{
				CustomProp = "Second item"
			});

			this.diagram.GraphSource = graphSource;

		}

		private void OnTextBoxLoaded(object sender, RoutedEventArgs e)
		{
			(sender as TextBox).GetBindingExpression(TextBox.TextProperty).UpdateTarget();
		}
	}

	public class MyNode : NodeViewModelBase
	{
		private string customProp;
		public string CustomProp
		{
			get
			{
				return this.customProp;
			}
			set
			{
				if (this.customProp != value)
				{
					this.customProp = value;
					this.OnPropertyChanged("CustomProp");
				}
			}
		}
	}
}
