﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using Telerik.Windows.Diagrams.Core;

namespace CustomSettingsPane
{
	public class MyConverter : IValueConverter
	{
		private object currentContent;
		private object initialValue;

		public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			this.initialValue = value;
			this.currentContent = null;
			var items = value as IEnumerable<IDiagramItem>;
			if (items != null && items.Count() == 1 && parameter != null)
			{
				this.currentContent = items.FirstOrDefault().Content;
				var property = this.currentContent.GetType().GetProperty(parameter.ToString());
				if (property != null)
				{
					return property.GetValue(this.currentContent, null).ToString();
				}
			}

			return this.initialValue;
		}

		public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
		{
			if (this.currentContent != null)
			{
				var property = this.currentContent.GetType().GetProperty(parameter.ToString());
				property.SetValue(this.currentContent, value);
			}

			return this.initialValue;
		}
	}
}
